(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define('formily.reactive-vue', ['exports'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.Formily = global.Formily || {}, global.Formily.ReactiveVue = {})));
})(this, (function (exports) { 'use strict';

    (function() {
        const env = {"NODE_ENV":"development"};
        try {
            if (process) {
                process.env = Object.assign({}, process.env);
                Object.assign(process.env, env);
                return;
            }
        } catch (e) {} // avoid ReferenceError: process is not defined
        globalThis.process = { env:env };
    })();

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
        var e = new Error(message);
        return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };

    // https://github.com/mobxjs/mobx-vue/blob/master/src/collectData.ts
    /**
     * @author Kuitos
     * @homepage https://github.com/kuitos/
     * @since 2018-06-08 10:16
     */

    function collectData(vm, data) {
        var dataDefinition = typeof data === 'function' ? data.call(vm, vm) : data || {};
        var filteredData = Object.keys(dataDefinition).reduce(function (result, field) {
            var value = dataDefinition[field];
            if (Formily.Reactive.isObservable(value)) {
                Object.defineProperty(vm, field, {
                    configurable: true,
                    get: function () {
                        return value;
                    },
                });
            }
            else {
                result[field] = value;
            }
            return result;
        }, {});
        return filteredData;
    }

    var noop = function () { };
    var disposerSymbol = Symbol('disposerSymbol');
    function observer$2(Component, observerOptions) {
        var name = (observerOptions === null || observerOptions === void 0 ? void 0 : observerOptions.name) ||
            Component.name ||
            Component._componentTag ||
            (Component.constructor && Component.constructor.name) ||
            '<component>';
        var originalOptions = typeof Component === 'object' ? Component : Component.options;
        // To not mutate the original component options, we need to construct a new one
        var dataDefinition = originalOptions.data;
        var options = __assign(__assign({ name: name }, originalOptions), { data: function (vm) {
                return collectData(vm || this, dataDefinition);
            }, 
            // overrider the cached constructor to avoid extending skip
            // @see https://github.com/vuejs/vue/blob/6cc070063bd211229dff5108c99f7d11b6778550/src/core/global-api/extend.js#L24
            _Ctor: {} });
        // we couldn't use the Component as super class when Component was a VueClass, that will invoke the lifecycle twice after we called Component.extend
        var superProto = typeof Component === 'function' &&
            Object.getPrototypeOf(Component.prototype);
        var Super = superProto instanceof VueDemi.Vue2 ? superProto.constructor : VueDemi.Vue2;
        var ExtendedComponent = Super.extend(options);
        var _a = ExtendedComponent.prototype, $mount = _a.$mount, $destroy = _a.$destroy;
        ExtendedComponent.prototype.$mount = function () {
            var _this = this;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var mounted = false;
            this[disposerSymbol] = noop;
            var nativeRenderOfVue;
            var reactiveRender = function () {
                Formily.Reactive.batch(function () {
                    tracker.track(function () {
                        if (!mounted) {
                            $mount.apply(_this, args);
                            mounted = true;
                            nativeRenderOfVue = _this._watcher.getter;
                            // rewrite the native render method of vue with our reactive tracker render
                            // thus if component updated by vue watcher, we could re track and collect dependencies by @formily/reactive
                            _this._watcher.getter = reactiveRender;
                        }
                        else {
                            nativeRenderOfVue.call(_this, _this);
                        }
                    });
                });
                return _this;
            };
            reactiveRender.$vm = this;
            var tracker = new Formily.Reactive.Tracker(function () {
                if (reactiveRender.$vm._isBeingDestroyed ||
                    reactiveRender.$vm._isDestroyed) {
                    return tracker.dispose();
                }
                if ((observerOptions === null || observerOptions === void 0 ? void 0 : observerOptions.scheduler) &&
                    typeof observerOptions.scheduler === 'function') {
                    observerOptions.scheduler(reactiveRender);
                }
                else {
                    reactiveRender();
                }
            });
            this[disposerSymbol] = tracker.dispose;
            return reactiveRender();
        };
        ExtendedComponent.prototype.$destroy = function () {
            this[disposerSymbol]();
            $destroy.apply(this);
        };
        var extendedComponentNamePropertyDescriptor = Object.getOwnPropertyDescriptor(ExtendedComponent, 'name') || {};
        if (extendedComponentNamePropertyDescriptor.configurable === true) {
            Object.defineProperty(ExtendedComponent, 'name', {
                writable: false,
                value: name,
                enumerable: false,
                configurable: false,
            });
        }
        return ExtendedComponent;
    }

    /* istanbul ignore next */
    var useObserver = function (options) {
        if (VueDemi.isVue3) {
            var vm_1 = VueDemi.getCurrentInstance();
            var tracker_1 = null;
            var disposeTracker_1 = function () {
                if (tracker_1) {
                    tracker_1.dispose();
                    tracker_1 = null;
                }
            };
            var vmUpdate_1 = function () {
                var _a;
                (_a = vm_1 === null || vm_1 === void 0 ? void 0 : vm_1.proxy) === null || _a === void 0 ? void 0 : _a.$forceUpdate();
            };
            VueDemi.onBeforeUnmount(disposeTracker_1);
            Object.defineProperty(vm_1, 'effect', {
                get: function () {
                    // https://github.com/alibaba/formily/issues/2655
                    return vm_1['_updateEffect'] || {};
                },
                set: function (newValue) {
                    vm_1['_updateEffectRun'] = newValue.run;
                    disposeTracker_1();
                    var newTracker = function () {
                        tracker_1 = new Formily.Reactive.Tracker(function () {
                            if ((options === null || options === void 0 ? void 0 : options.scheduler) && typeof options.scheduler === 'function') {
                                options.scheduler(vmUpdate_1);
                            }
                            else {
                                vmUpdate_1();
                            }
                        });
                    };
                    var update = function () {
                        var refn = null;
                        tracker_1 === null || tracker_1 === void 0 ? void 0 : tracker_1.track(function () {
                            refn = vm_1['_updateEffectRun'].call(newValue);
                        });
                        return refn;
                    };
                    newTracker();
                    newValue.run = update;
                    vm_1['_updateEffect'] = newValue;
                },
            });
        }
    };

    /* istanbul ignore next */
    var observer$1 = function (opts, options) {
        var name = (options === null || options === void 0 ? void 0 : options.name) || opts.name || 'ObservableComponent';
        return __assign(__assign({ name: name }, opts), { setup: function (props, context) {
                var _a;
                useObserver(options);
                return (_a = opts === null || opts === void 0 ? void 0 : opts.setup) === null || _a === void 0 ? void 0 : _a.call(opts, props, context);
            } });
    };

    function observer(baseComponent, options) {
        /* istanbul ignore else */
        if (VueDemi.isVue2) {
            return observer$2(baseComponent, options);
        }
        else {
            return observer$1(baseComponent, options);
        }
    }

    exports.collectData = collectData;
    exports.observer = observer;
    exports.useObserver = useObserver;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=formily.reactive-vue.umd.development.js.map
