"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useObserver = void 0;
var reactive_1 = require("@formily/reactive");
var vue_demi_1 = require("vue-demi");
/* istanbul ignore next */
var useObserver = function (options) {
    if (vue_demi_1.isVue3) {
        var vm_1 = (0, vue_demi_1.getCurrentInstance)();
        var tracker_1 = null;
        var disposeTracker_1 = function () {
            if (tracker_1) {
                tracker_1.dispose();
                tracker_1 = null;
            }
        };
        var vmUpdate_1 = function () {
            var _a;
            (_a = vm_1 === null || vm_1 === void 0 ? void 0 : vm_1.proxy) === null || _a === void 0 ? void 0 : _a.$forceUpdate();
        };
        (0, vue_demi_1.onBeforeUnmount)(disposeTracker_1);
        Object.defineProperty(vm_1, 'effect', {
            get: function () {
                // https://github.com/alibaba/formily/issues/2655
                return vm_1['_updateEffect'] || {};
            },
            set: function (newValue) {
                vm_1['_updateEffectRun'] = newValue.run;
                disposeTracker_1();
                var newTracker = function () {
                    tracker_1 = new reactive_1.Tracker(function () {
                        if ((options === null || options === void 0 ? void 0 : options.scheduler) && typeof options.scheduler === 'function') {
                            options.scheduler(vmUpdate_1);
                        }
                        else {
                            vmUpdate_1();
                        }
                    });
                };
                var update = function () {
                    var refn = null;
                    tracker_1 === null || tracker_1 === void 0 ? void 0 : tracker_1.track(function () {
                        refn = vm_1['_updateEffectRun'].call(newValue);
                    });
                    return refn;
                };
                newTracker();
                newValue.run = update;
                vm_1['_updateEffect'] = newValue;
            },
        });
    }
};
exports.useObserver = useObserver;
//# sourceMappingURL=useObserver.js.map